Fix pathbay figure placing
[goodguy/cin-manual-latex.git] / parts / Instalation.tex
index 8994974a39c43ed7f0bac557924992c353e0e98a..d84630dae5fd139b2b25245acaa06346af798ee1 100644 (file)
 \chapter{Installation}
 \label{cha:Instalation}
+\section{How to Build Cinelerra-GG from Developer's Git Repository}%
+\label{sec:How_to_build}
+
+These are generic build instructions for building Cinelerra-GG Infinity.  
+Known to work on ubuntu, mint, suse/leap, fedora, debian, centos, arch, and slackware.  
+It has not been tested on every single possible distro yet so you might expect to have to make some minor changes.  
+Patches have been created to build on FreeBSD through the work of another programmer and a Gentoo version is being maintained elsewhere by another programmer.
+
+Alternatively, there are some pre-built dynamic or static binaries which are updated on a fairly regular basis (as long as code changes have been made) available at the link below.
 
-This manual covers features or areas of Cinelerra that are different or new in the Cinelerra-GG Infinity
-version. Many of the new features were created by a lot of different people to include the original
-author and were merged in from various sources and each person is to be commended for their efforts.
-The content of this manual also came from various people/places/email and thanks to all.
 
-The standard Cinelerra Manual covers “The Secrets of Cinelerra” and can be found at:\par
 \url{
-https://cinelerra-cv.org/docs/cinelerra_cv_manual_en.html
+https://cinelerra-gg.org/download/
 }
-\section{How to Build Cinelerra-GG Infinity from Developer's Git Repository}%
-\label{sec:}
-
-These are generic build instructions for building Cinelerra-GG Infinity. Known to work on ubuntu,
-mint, suse, fedora, debian, centos, arch, and 32-bit slackware. It has not been tested on every single
-possible distro yet so you might expect to have to make some minor changes. It has failed miserably
-on FreeBSD. At least once, a Gentoo version was successfully created.
-
-Alternatively, there are some pre-built dynamic or static binaries which are updated on a fairly regular
-basis (as long as code changes have been made) available at link below. See Section 1.2.
-
-\url{https://cinelerra-gg.org/download/}
-    There are 2 kinds of builds, the default system-build and a single-user build. A system build has results
-which are installed to the system. The majority of the files are installed in the standard system paths,
-but some customization is possible. The single user build allows for running completely out of a local
-user directory so it doesn't affect the system.
-
-We recommend the single-user version when possible. It makes it very easy to install a new version
-without having to delete the older version in case you want it for backup – once you are happy with the
-new version, all you have to do is delete the entire old directory path. Also, if you install a new
-Operating System version and if you have Cinelerra on separate disk space that is preserved, you won't
-have to reinstall Cinelerra. In addition for purposes of having the ability to interrupt or to see any
-possible error messages, if you start the application from a terminal window command line you will
-have more control to catch problems. The system builds can be useful in a university lab setting where
-there are possibly multiple users, or multiple versions.
-
-There are two notable differences between “standard” views of Cinelerra and this implementation for
-the system builds. Both of these can be configured during installation. These differences make it
-possible to have several different versions installed without having them “walk” on each other.ault system-build an
+
+There are 2 kinds of builds, the default system-build and a single-user build.  
+A system build has results which are installed to the system. 
+The majority of the files are installed in the standard system paths, but some customization is possible. 
+The single user build allows for running completely out of a local user directory so it doesn't affect the system.
+
+We recommend the single-user version when possible.  
+It makes it very easy to install a new version without having to delete the older version in case you want it for backup – once you are happy with the new version, all you have to do is delete the entire old directory path.  
+Also, if you install a new Operating System version and if you have Cinelerra on separate disk space that is preserved, you won't have to reinstall Cinelerra.  
+In addition for purposes of having the ability to interrupt or to see any possible error messages, if you start the application from a terminal window command line you will have more control to catch problems.  
+However, the system builds can be useful in a university lab setting where there are possibly multiple users, or multiple versions.
+
+There are two notable differences between “standard” views of Cinelerra and this implementation for the system builds.  
+Both of these can be configured during installation.  
+These differences make it possible to have several different versions installed without having them “walk” on each other. 
+
+
+
+
+
+
+
+
+
 
 \begin{enumerate}
     \item 
         application name can be set during installation and defaults to: “\texttt{cin}”
-        \item 
-            the home configuration directory can also be set and defaults to:\\ “\texttt{\$HOME/.bcast5}”
-
-
+    \item 
+        the home configuration directory can also be set and defaults to:\\ “\texttt{\$HOME/.bcast5}”
 \end{enumerate}
+
 \paragraph{To do a system build,} you should read the \texttt{README} that is at the top level after you get the source.
 
 \begin{enumerate}
     \item 
-        You need at least 2.5GB of disk storage to operate a build. Need to have “\texttt{git}” installed.
-    \item  Obviously in order to install into the system, you must run as root.
-    \item  The "\texttt{git}" step has to download a bunch of stuff (approx 100MB) so allow time.
+        You need at least 2.5\,GB of disk storage to operate a build + you need to have “\texttt{git}” installed.
+    \item  Obviously in order to install into the system, you must run as \textbf{root}.
+    \item  The "\texttt{git}" step has to download many files (approx 100\,MB) so allow time.
     \item  Run the following commands (this takes awhile):
+
         \begin{lstlisting}[language=bash]
-cd /<build_path>/
-# this is where you need the 2.5GB of disk space
-git clone --depth 1 "git.cinelerra-gg.org/goodguy/cinelerra.git" cinelerra5
-cd cinelerra5/cinelerra-5.1 # toplevel directory
+$ cd /<build_path>/           # this is where you need the 2.5GB of disk space
+$ git clone --depth 1 "git://git.cinelerra-gg.org/goodguy/cinelerra.git" cinelerra5 
+$ cd cinelerra5/cinelerra-5.1 # toplevel directory
         \end{lstlisting}
-        NOTE: if your system has never had Cinelerra-GG Infinity installed, you will have to make sure you
-        have all of the compilers and libraries necessary. So on the very first build you should run:
 
+        NOTE: if your system has never had Cinelerra-GG Infinity installed, you will have to make sure you have all of the compilers and libraries necessary.  
+        So on the very first build you should run:
+
+        \begin{lstlisting}[language=bash]
+$ ./blds/bld_prepare.sh <os> # where <os> represents the Operating System of centos, fedora, suse, leap, ubuntu, debian.
+$ ./autogen.sh
+$ ./configure --prefix=/usr  # optional parameters can be added here
+$ make 2>&1 | tee log        # make and log the build
+        \end{lstlisting}
+    \item  Check for obvious build errors:
+        \begin{lstlisting}[language=bash]
+$ grep "\*\*\*.*error" -ai log
+        \end{lstlisting}
+        If this reports errors and you need assistance or you think improvements can be made to the build s,
+        email the log which is listed below to \url{cin@lists.cinelerra-gg.org:}
+        \begin{lstlisting}[language=bash]
+$ /<build_path>/cinelerra5/cinelerra-5.1/log
+        \end{lstlisting}
+    \item  If there are no build errors, finally just run:
         \begin{lstlisting}[language=bash]
-./blds/bld_prepare.sh <os> # where <os> represents the Operating System of centos, fedora, suse, leap, ubuntu, debian.
-./autogen.sh
-./configure --prefix=/usr
-# optional parameters can be added here
-make 2>&1 | tee log
-# make and log the build
-\end{lstlisting}
-\item  Check for obvious build errors:
-    \begin{lstlisting}[language=bash]
-grep "\*\*\*.*error" -ai log
-    \end{lstlisting}
-    If this reports errors and you need assistance or you think improvements can be made to the build s,
-    email the log which is listed below to cin@lists.cinelerra-gg.org:
-    \begin{lstlisting}[language=bash]
-/<build_path>/cinelerra5/cinelerra-5.1/log
-    \end{lstlisting}
-\item  If there are no build errors, finally just run:
-    \begin{lstlisting}[language=bash]
-    make install
-    \end{lstlisting}
-\item  If it all worked, you are all setup. Just click on the “blue lady” cinelerra desktop icon.
+   $  make install
+        \end{lstlisting}
+    \item  If it all worked, you are all setup. Just click on the cinelerra desktop icon.
 \end{enumerate}
 
 \paragraph{To do a single-user build,} read the \texttt{README} that is at the top level after you get the source.
 \begin{enumerate}
-    \item  You need at least 2.5GB of disk storage to operate a build. Need to have “\texttt{git}” installed.
-    \item  Recommend you build and run as root, just to avoid permission issues initially.
-    \item  The "\texttt{git}" step has to download a bunch of stuff (approx 100MB) so allow time.
+    \item  You need at least 2.5\,GB of disk storage to operate a build + you need to have  “\texttt{git}” installed.
+    \item  Recommend you build and run as \textbf{root}, just to avoid permission issues initially.
+    \item  The "\texttt{git}" step has to download many files (approx 100\,MB) so allow time.
     \item  Run the following commands (this takes awhile):
         \begin{lstlisting}[language=bash]
-cd /<build_path>/
-# this is where you need the 2.5GB of disk space
-git clone --depth 1 "git://git.cinelerra-gg.org/goodguy/cinelerra.git" cinelerra5
-cd cinelerra5/cinelerra-5.1
+$ cd /<build_path>/           # this is where you need the 2.5GB of disk space
+$ git clone --depth 1 "git://git.cinelerra-gg.org/goodguy/cinelerra.git" cinelerra5 
+$ cd cinelerra5/cinelerra-5.1 # toplevel directory
         \end{lstlisting}
 \end{enumerate}
+
 NOTE: if your system has never had Cinelerra-GG Infinity installed, you will have to make sure all
-the compilers and libraries necessary are installed. So on the very first build you should run as root:
+the compilers and libraries necessary are installed. So on the very first build you should run as \textbf{root}:
+
 \begin{lstlisting}[language=bash]
-./blds/bld_prepare.sh <os> # where <os> represents the Operating System of
-centos, fedora, suse, leap, ubuntu, debian.
-./autogen.sh
-./configure --with-single-user
-# the “with-single-user” parameter makes it so
-make 2>&1 | tee log
-# make and log build (check for errors before proceeding)
-make install
+$ ./blds/bld_prepare.sh <os>     # where <os> represents the Operating System of centos, fedora, suse, leap, ubuntu, debian.
+$ ./autogen.sh
+$ ./configure --with-single-user # the “with-single-user” parameter makes it so
+$ make 2>&1 | tee log            # make and log build (check for errors before proceeding)
+$ make install
 \end{lstlisting}
 
 Then just start the application by keying in: ./cin in the bin subdirectory OR add a desktop icon by
-using the appropriate directory to copy the files to, run as root, and edit to correct the directory path.
+using the appropriate directory to copy the files to, run as \textbf{root}, and edit to correct the directory path.
 
 \begin{lstlisting}[language=bash]
-cd /cinelerra_directory_path
-cp -a image/cin.{svg,xpm} /usr/share/pixmaps/.
-cp -a image/cin.desktop /usr/share/applications/cin.desktop
-change the “Exec=cin” line to be “Exec=<your_directory_path>/bin/cin”
+$ cd /cinelerra_directory_path
+$ cp -a image/cin.{svg,xpm} /usr/share/pixmaps/.
+$ cp -a image/cin.desktop /usr/share/applications/cin.desktop
 \end{lstlisting}
+Change the “Exec=cin” line to be “Exec=<your\_directory\_path>/bin/cin”
 
 The preceding directions for doing a single-user build has been meticulously followed to build and run
 on a newly installed ubuntu 15 system WITHOUT BEING ROOT except for the \texttt{bld\_prepare.sh} and creating the desktop icon.
+
+\subsection{Notable Options and Caveats}%
+\label{sub:notable_options_and_caveats}
+
+These procedures and the Cinelerra-GG Infinity software have all been run as “\textbf{root}” on various home laptops and desktops. This provides the best chance to ensure all works correctly and also allows for handling errors, other problems and potential crashes with the most success.  Included in this section are some of the build variations easily available for normal builds.
+
+To see the full list of features use:   
+
+\begin{lstlisting}[language=bash]
+$ ./configure –help
+\end{lstlisting}
+The default build is a system build which uses:    
+
+\begin{lstlisting}[language=bash]
+$ ./configure –without-single-user
+\end{lstlisting}
+
+In the single-user build, the target directory is always “cin”.  
+Because this is also the developer build, constant names are used throughout.  
+However, you can rename files after the install is complete.
+
+f your distro/operating system has issues with the default install to \texttt{/usr/local}, you might have to change the location to /usr for a system build.  Then you will have to use:
+\begin{lstlisting}[language=bash]
+$ ./configure --prefix=/usr
+\end{lstlisting}
+
+If you wish to change the default directory for a system build you will have to add the destination directory path on the “\texttt{make install}” line.  For example:
+\begin{lstlisting}[language=bash]
+$ make install DESTDIR=<your selected target directory path>
+\end{lstlisting}
+
+The application name can be set during installation, but defaults to cin so that the GG/Infinity build can coexist with other Cinelerra builds if necessary.  To override the default cin name, use:   
+\begin{lstlisting}[language=bash]
+$ ./configure --with-exec-name=cinelerra
+\end{lstlisting}
+
+The home configuration directory can also be set, but defaults to \texttt{\$\$HOME/.bcast5}.  
+For example:
+
+\begin{lstlisting}[language=bash]
+$ ./configure –with-config-dir=/myusername/.bcast5
+\end{lstlisting}
+
+NOTE:  when you specify parameters to the configure program, it will create a make file as a consequence.  
+Since in a make file, the \$ is a special character, it must be escaped so in order to represent a \$ as part of an input parameter, it has to be stuttered.  
+That is, you will need \$\$ (2 dollar signs) to represent a single dollar sign. 
+
+It may be necessary on some distros which have missing or incomplete up-to-date libraries, to build cinelerra without Ladspa.  
+To do so, use:
+
+\begin{lstlisting}[language=bash]
+$ ./configure --prefix=/usr --without-ladspa-build
+\end{lstlisting}
+
+Note that the with-ladspa-dir is the ladspa search path, and exists even if the ladspa build is not selected.  This gives you the ability to specify an alternate ladspa system path by utilizing the \texttt{LADSPA\_PATH} environment variable (that is, the default ladspa build is deselected).
+
+Note for 32-bit 14.2 Slackware, Debian, Gentoo, Arch, FreeBSD, before running the configure, you will need to set up the following:
+
+\begin{lstlisting}[language=bash]
+$ export ac_cv_header_xmmintrin_h=no
+$ export FFMPEG_EXTRA_CFG=" --disable-vdpau"
+\end{lstlisting}
+
+\subsection{Notes about Building from Git in your Customized Environment}%
+\label{sub:notes_about_building_from_git_in_your_customized_environment}
+
+Getting a build to work in a custom environment is not easy.  If you have already installed libraries which are normally in the thirdparty build, getting them to be recognized means you have to install the "devel" version so the header files which match the library interfaces exist.  Below is the list of thirdparty builds, but this list may have changed over time:
+% It's list of Table?
+
+\begin{table}[htpb]
+    \centering
+    \caption{List of thirdparty builds}
+    \label{tab:List_of_thirdparty_builds}
+        \small
+    \begin{tabular}{m{8em}c}
+        \toprule
+       a52dec   & yes\\
+       djbfft   & yes\\
+       fdk      & auto\\
+       ffmpeg   & yes\\
+       fftw     & auto\\
+       flac     & auto\\
+       giflib   & yes\\
+       ilmbase&auto\\
+       lame    &  auto\\
+       libavc1394&auto\\
+       libraw1394&auto\\
+       libiec61883&auto\\
+       libdv     &auto\\
+       libjpeg   &auto\\
+       openjpeg  &auto\\
+       libogg    &auto\\
+       libsndfile&auto\\
+       libtheora&auto\\
+       libuuid  & yes\\
+       libvorbis&auto\\
+       mjpegtools&yes\\
+       openexr   &auto\\
+       tiff      &auto\\
+       twolame   &auto\\
+       x264      &auto\\
+       x265      &auto\\
+       libvpx  &auto\\
+       libwebp&auto\\
+       libaom& auto\\
+    \bottomrule
+    \end{tabular}
+\end{table}
+
+
+The "yes" means force build and “auto” means probe and use the system version if the build operation is not static.  
+To get your customized build to work, you need to change the probe options for the conflicting libraries from "yes" to "auto", or even rework the \texttt{configure.ac} script.  
+There may be several libraries which need special treatment.
+
+An example of a problem you might encounter with your customized installation is with “\texttt{a52dec}” which has probes \texttt{(CHECK\_LIB/CHECK\_HEADER)} in \texttt{configure.ac}, but \texttt{djbfft} does not.  
+In this case, \texttt{djbfft} is only built because \texttt{a52dec} is built, so if your system has \texttt{a52dec}, set \texttt{a52dec} to auto and see if that problem is solved by retrying the build with:  
+\begin{lstlisting}[language=bash]
+$ ./confgure --with-single-user –enable-a52dec=auto .
+\end{lstlisting}
+
+With persistence, you can get results, but it may take several tries to stabilize the build.  
+If you need help, email the "\texttt{log}" and "\texttt{config.log}", which is usually sufficient to determine why a build failed.
+\vspace{5ex}
+
+If you have already installed the \texttt{libfdk\_aac} development package on your computer because you prefer this version over the default aac, you will have to do the following to get this alternative operational.
+
+\begin{lstlisting}[language=bash]
+$ export FFMPEG_EXTRA_CFG=" --enable-libfdk-aac --enable-nonfree"
+$ export EXTRA_LIBS=" -lfdk-aac"
+$ for f in `grep -lw aac cinelerra-5.1/ffmpeg/audio/*`; do
+$   sed -e 's/\<aac\>/libfdk_aac/' -i $f
+$ done
+\end{lstlisting}
+
+\subsection{Cloning the Repository for Faster Updates}%
+\label{sub:cloning_the_repository_for_faster_updates}
+
+If you want to avoid downloading the software every time an update is available you need to create a local "repository" or repo.  
+The repo is a directory where you first do a “\texttt{git clone}”.  
+For the initial git clone, setup a local area for the repository storage, referred to as \texttt{<repo\_path>}.  
+The “\texttt{git clone}” creates a repo named "\texttt{cin5}" in the \texttt{/<repo\_path>/} directory.  
+This accesses over 300\,MB of repo data, so the device has to have at least that available.  
+The repo path is always a perfect clone of the main repo.
+
+\paragraph{Setting up the initial clone}%
+\label{par:setting_up_the_initial_clone}
+add “\texttt{ -\,- depth 1}” before cin5 which is faster/smaller, but has no history.
+
+\begin{lstlisting}
+$ cd /<repo\_path>/
+$ git clone "git://git.cinelerra-gg.org/goodguy/cinelerra" cin5
+
+Cloning into "cin5"...
+remote: Counting objects: 20032, done.
+remote: Compressing objects: 100% (11647/11647), done.
+remote: Total 20032 (delta 11333), reused 16632 (delta 8189)
+Receiving objects: 100% (20032/20032), 395.29 MiB | 3.26 MiB/s, done.
+Resolving deltas: 100% (11333/11333), done.
+Checking connectivity... done.
+\end{lstlisting}
+
+\paragraph{Update an existing repo}%
+\label{par:update_an_existing_repo}
+
+\begin{lstlisting}[language=bash]
+ $ cd /<repo home>/cin5
+ $ git pull
+\end{lstlisting}
+
+\paragraph{Useful git commands}%
+\label{par:useful_git_commands}
+
+
+\begin{lstlisting}[language=bash]
+$ git clone "git://git.cinelerra-gg.org/goodguy/cinelerra.git" cin5
+$ git pull         # pull remote changes to the local version
+$ git status       # shows changed files
+$ git clean -i     # interactive clean, use answer 1 to "clean"
+\end{lstlisting}
+
+
+
+\subsection{How to Build from a Previous GIT Version}%
+\label{sub:how_to_build_from_a_previous_git_version}
+
+
+\begin{lstlisting}[language=bash]
+$ cd /<path>/cin5_repo
+$ git log
+$ git checkout <version>
+\end{lstlisting}
+
+
+The “git log” command produces a log file with hash values for commit keys.  The hash ids are the commit names to use when you use git checkout.  
+Next is displayed sample output:
+
+
+\begin{lstlisting}
+delete stray line in last checkin
+
+commit 4a90ef3ae46465c0634f81916b79e279e4bd9961
+Author: Good Guy <good1.2guy@gmail.com>
+Date: Thu Feb 22 14:56:45 2018 -0700
+
+nested clips, big rework and cleanup, sams new icons, leaks and tweaks
+
+commit f87479bd556ea7db4afdd02297fc00977412b873
+Author: Good Guy <good1.2guy@gmail.com>
+Date: Sat Feb 17 18:09:22 2018 -0700
+\end{lstlisting}
+
+For the “git checkout <version>, you would then keyin the line below for the following results:
+
+\begin{lstlisting}
+$ git checkout f87479bd556ea7db4afdd02297fc00977412b873
+
+Note: checking out 'f87479bd556ea7db4afdd02297fc00977412b873'.
+
+       You are in 'detached HEAD' state. You can look around, make experimental
+       changes and commit them, and you can discard any commits you make in this
+       state without impacting any branches by performing another checkout.
+
+       If you want to create a new branch to retain commits you create, you may
+       do so (now or later) by using -b with the checkout command again. Example:
+
+       git checkout -b <new-branch-name>
+
+       HEAD is now at f87479bd... more file size icon updates, and more to followend
+\end{lstlisting}
+
+Later to get the repo back to current, use:    
+\begin{lstlisting}
+$ git checkout master
+\end{lstlisting}
+
+
+\subsection{Debuggable Single User Build}%
+\label{sub:debuggable_single_user_build}
+
+
+To build from source with full debugging symbols, first build a full static (non\_debug) build as follows but instead /tmp substituted with a permanent disk path if you want to keep it.
+
+\begin{lstlisting}
+$ git clone ...
+$ cp -a /path/cinelerra-5.1 /tmp/.
+$ cd /tmp/cinelerra-5.1
+$ ./bld.sh
+\end{lstlisting}
+
+
+Then, to run as a developer in the debugger:
+
+\begin{lstlisting}[language=bash]
+$ CFLAGS=”-O2 -ggdb” make -j8 rebuild_all
+$ cd cinelerra
+$ gdb ./ci
+\end{lstlisting}
+
+
+\subsection{Unbundled Builds}%
+\label{sub:unbundled_builds}
+
+There are some generic build scripts included in the Cinelerra-GG GIT repository for users who want to do unbundled builds with ffmpeg already available on their system.  
+This has been tested on Arch, Ubuntu 18, FreeBSD, and Leap 15 (rpm) at the time this was documented.  
+The names of the build scripts are:  arch.bld ,  bsd.bld , deb.bld , and rpm.bld .  
+These scripts are in the “blds” subdirectory.  
+The bsd.bld should be used with the bsd.patch file in that same directory.
+
+The reason that Cin Infinity traditionally uses thirdparty builds (bundled builds) is because there are a lot of different distros with varying levels of ffmpeg and other needed thirdparty libraries.  
+However, some users prefer using their current system baseline without another/different copy of ffmpeg.  
+With different levels of the user’s libraries, uncertainty, potential instability, and unknown issues may come up while running Cinelerra and this will make it, for all practical purposes, impossible to diagnose and debug problems or crashes.  
+There may be no help in these cases.  You are encouraged to report any errors which potentially originate from Cin Infinity, but if the data indicates alternate library sources, please report the problems to the appropriate maintainers.
+
+With the unbundled builds, some features may not be available and no attempt to comment them out has been made.  
+So if you use a pulldown, or pick a render option, or choose something that is not available, it just will not work.  
+For example, unless special options were set up by you, the LV2 audio plugins will not be available.  
+Nor will the codec libzmpeg, the file codec ac3, or DVD creation.  
+The old school file classes will all work, but some of the formats that come with ffmpeg may not because of the way that ffmpeg was installed on your operating system.  
+That is because the Cinelerra ffmpeg is a known static build and is usually the latest stable/released version.  
+In the current case of Leap 15, libx264 and libx265 are not built in and this can be debilitating;  You can always run “ffmpeg -formats” and “ffmpeg -codecs” to see what is available on your system.
+
+
+\section{Download Already Built Cinelerra-GG}%
+\label{sec:download_already_built_cinelerra_gg}
+
+If you prefer to not have to take the time to build Cinelerra-GG Infinity yourself, there are pre-built dynamic or static binaries for various versions of ubuntu, mint, suse, fedora, debian, centos, arch, and slackware linux as well as Gentoo and FreeBSD.  
+There are also 32-bit i686 ubuntu, debian, and slackware versions available.  
+These are updated on a fairly regular basis as long as significant code changes have been made.  
+They are in subdirectories of:
+
+\url{https://cinelerra-gg.org/download/tars}
+
+\url{https://cinelerra-gg.org/download/pkgs}
+
+The “\textbf{tars}” directory contains single-user static builds for different distros.  
+This is the recommended usage of Cinelerra-GG because all of the files will exist in a single directory.  
+To install the single user builds, download the designated tarball from the ./tars subdirectory and unpack as indicated below:
+
+\begin{lstlisting}[language=bash]
+$ cd /path
+$ mkdir cin
+$ cd cin
+$ tar -xJf /src/path/cinelerra-5.1-*.txz    # for the *, substitute your distro tarball name
+\end{lstlisting}
+
+Do NOT download the LEAP 10-bit version unless you use h265 (it can't render 8-bit h265).
+
+The “\textbf{pkgs}” directory contains the standard packaged application for various distros.  
+This will install a dynamic system version for users who prefer to have the binaries in the system area and for multi-user systems.  
+In addition, performing the package install checks the md5sum in the file md5sum.txt to ensure the channel correctly transmits the package.  
+There is a README.pkgs file in the “pkgs” directory with instructions so you can “cut and paste” and avoid typos; it is also shown next.
+
+%TODO point to real READ.pkgs
+
+\begin{lstlisting}
+Depending on the distro, use the instructions below and select the appropriate 
+setup operations to install, update or remove cinelerr-gg infinity.  (03/04/2019)
+To upgrade, refresh repo, then replace "install" with "update", or whatever.
+
+Email problems to cin@lists.cinelerra-gg.org
+If repository problems, usually you can manually do an install by using:
+  wget https://cinelerra-gg.org/download/pkgs/{substitute_name}/cin_5.1.<sub_name>.deb
+  and install it manually, for example: dpkg -i cin_5.1.{substitute_filename}.deb
+
+# GENTOO – courtesy Dominque Michel
+# There is an ebuild package at this time as of 01/03/2019 at:
+#    https://svnweb.tuxfamily.org/listing.php?repname=proaudio%2Fproaudio&path=
+#    %2Ftrunk%2Foverlays%2Fproaudio%2Fmedia-video%2Fcinelerra%2F&#ab000caf7024d83112f42a7e8285f2f29
+
+# FREEBSD – courtesy Yuri
+# There is a port available at: https://www.freshports.org/multimedia/cinelerra-gg/
+# To use this port: cd /usr/ports/multimedia/cinelerra-gg && make install clean
+#   and then install this precompiled package via: pkg install cinelerra-gg
+
+# FEDORA
+# Replace the XX in fedoraXX in the next line with your current O/S version number
+dnf install cinelerra --nogpgcheck --repofrompath cingg,https://cinelerra-gg.org/download/pkgs/fedoraXX/
+##dnf erase cinelerra
+
+# CENTOS
+# Python 2 has been updated for other distros to Python 3 so you might have to create a soft link
+#   to get the correct version.  For help, send email to cin@lists.cinelerra-gg.org
+# first create the file /etc/yum.repos.d/cin_gg, with the following contents:
+[cin_gg]
+name=cingg
+baseurl=https://cinelerra-gg.org/download/pkgs/centos7
+gpgcheck=0
+# end of cin_gg
+yum install cinelerra
+##yum erase cinelerra
+
+# UBUNTU, replace ub14 with your distro id: ub16,ub17,ub18
+#  Some ubuntu apt downloads register status as working 0% constantly while running the package
+#   download, like ubuntu 14.  It may take a few minutes for this step so be patient.
+apt install software-properties-common apt-transport-https
+apt-add-repository https://cinelerra-gg.org/download/pkgs/ub14
+# UBUNTU 16/17/18 note - This has been known to work, but things change quickly:
+# VIP - for the first install, the above line adds cinelerra to /etc/apt/sources.list but...
+# Version 16/17/18 of Ubuntu are more strict for licensing so you will have to edit
+#  the file /etc/apt/sources.list to add [trusted=yes] after deb and before https...cin...
+# For example the line should be: deb [trusted=yes] https://cinelerra-gg.org/download/pkgs/ub16 xenial main
+#   Or for ub17: deb [trusted=yes] https://cinelerra-gg.org/download/pkgs/ub17 zesty main
+#   Or for ub18: deb [trusted=yes] https://cinelerra-gg.org/download/pkgs/ub18 bionic main
+# Also, on the install you will get an error message that you can either ignore as cinelerra
+#  will run anyway, or else (the first time only) on the commnand line keyin: 
+#  echo > /etc/sysctl.d/50-cin.conf "kernel.shmmax=0x7fffffff"
+apt update
+apt install cin
+#to update a previous install (ignore any i386 errors as only 64 bit version available):
+apt update
+apt upgrade cin
+##apt remove cin
+
+# MINT should use the same procedure as Ubuntu, but: 
+# Note: apt-add-repository did not work for me, I had to use the gui version:
+#  System_OR_Administration->Software Sources->Additional Repositories->Add a new repository
+#  For Mint18,add: deb [trusted=yes] https://cinelerra-gg.org/download/pkgs/mint18 xenial main
+#  For Mint19,add: deb [trusted=yes] https://cinelerra-gg.org/download/pkgs/mint19 bionic main 
+apt update
+apt install cin
+#to update a previous install
+apt update
+apt upgrade cin
+##apt remove cin
+
+# DEBIAN uses the same basic procedure as Ubuntu.
+#  The apt-add-repository varies per system so you will have to use your best judgement
+apt install software-properties-common apt-transport-https
+apt-add-repository https://cinelerra-gg.org/download/pkgs/debian8
+OR apt-add-repository https://cinelerra-gg.org/download/pkgs/debian9
+# VIP - for the first install, the above line adds cinelerra to /etc/apt/sources.list but...
+# Debian stretch and jessie are more strict for licensing so you will have to edit
+#  the file /etc/apt/sources.list to add [trusted=yes] after deb and before https...cin...
+# For example for debian8: deb [trusted=yes] https://cinelerra-gg.org/download/pkgs/debian8 jessie main
+# For example for debian9: deb [trusted=yes] https://cinelerra-gg.org/download/pkgs/debian9 stretch main
+apt update
+apt install cin
+#to update a previous install
+apt update
+apt upgrade cin
+##apt remove cin
+
+# SUSE/LEAP
+# (Note: you may have to zypper libavc and libiec versions if not already installed)
+# cinelerra packages are unsigned so you will have to ignore: Package is not signed!
+# openSUSE LEAP 15
+zypper ar -f https://cinelerra-gg.org/download/pkgs/leap15/ cingg
+zypper install -r cingg cinelerra   # or cinelerra10bit for 10 bit
+# openSUSE LEAP 42
+zypper ar -f https://cinelerra-gg.org/download/pkgs/leap42/ cingg
+# as of 42.3 SUSE there is a new requirement, so you will need to add:
+zypper mr -G cingg
+zypper install -r cingg cinelerra   # or cinelerra10bit for 10 bit
+##zypper remove cinelerra          # or cinelerra10bit for 10 bit
+#to update a previous install (assuming you enabled autorefresh as above)
+zypper refresh cingg
+zypper up cinelerra  # or cinelerra10bit for 10 bit
+
+# SLACKWARE, substitute slk32 for slk64 and i486-1 for x86_64-1
+wget -P /tmp https://cinelerra-gg.org/download/pkgs/slk64/cin-{date}-slk64-x86_64.txz
+installpkg /tmp/cin...    # name you used in the above line
+#to update a previous install
+upgradepkg /tmp/cin...    # name you used in the above line
+##removepkg cin
+
+# ARCH linux
+# first edit the file /etc/pacman.conf, to include the following:
+[cingg]
+SigLevel = Optional TrustAll
+Server = https://cinelerra-gg.org/download/pkgs/arch
+# end of cingg
+pacman -Sy
+pacman -S cin
+##pacman -R cin
+\end{lstlisting}
+
+\section{Distribution Systems with Cinelerra Included}%
+\label{sec:distribution_systems_with_cinelerra_included}
+
+There are also some special complete distribution systems available that include Cinelerra-GG for audio and video production capabilities.
+
+AV Linux is a downloadable/installable shared snapshot ISO image based on Debian. 
+It provides the user an easy method to get an Audio and Video production workstation without the hassle of trying to find and install all of the usual components themselves. 
+Of course, it includes Cinelerra-GG!  
+It is at:
+
+\url{http://www.bandshed.net/avlinux/}
+
+Bodhi Linux is a free and open source distribution that comes with a curated list of open source software for digital artists who work with audio, video, includes Cinelerra GG, games, graphics, animations, physical computing, etc.  
+It is at:
+
+\url{https://gitlab.com/giuseppetorre/bodhilinuxmedia} 
+
+\section{Cinx and a “Bit” of Confusion}%
+\label{sec:cinx_and_a_bit_of_confusion}
+
+Cinx is the exact same program as Cin.  
+The X (x) represents the roman numeral 10 for 10-bit as opposed to 8-bit standard.  
+The third-party library used for x265 must be specially compiled with \texttt{--bit-depth=10} in order to produce 10-bit rendered output.  
+This build will not be able to output 8-bit depth which means you have to retain the Cin version also.  
+Whatever build ffmpeg is linked to will determine what bit depth it can output.  
+This is why there have to be separate builds.  
+If you install both packages, Cin and CinX, you may get “file conflicts of same file name” --- just continue.
+
+Keep in mind that the regular 8-bit version works on 8-bit bytes --- the standard word size for computers, but the 10-bit version has to use 2 words to contain all 10 bits so you can expect rendering to be as much as twice as slow.  
+There is also a 12-bit version for consideration but currently the results are simply the same as 10-bit with padding to make 12-bit so it is of no value.
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+